VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPattern"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private p_FilePath As String     'p^[t@C̃pX
Private c_IniEdit As clsIniEdit  'Init@CNX
Private colPattern As Collection
Private lngPatternCount As Long
Private dblScale As Double
Private dblMagnification As Double


'NX
Private Sub Class_Initialize()
    Set c_IniEdit = New clsIniEdit
End Sub
'NXj
Private Sub Class_Terminate()
    Set colPattern = Nothing
    Set c_IniEdit = Nothing
End Sub

'p^[t@CpXvpeB
Public Property Let PatternFilePath(FilePath As String)

    Set colPattern = Nothing
    Set colPattern = New Collection
    p_FilePath = FilePath
    With c_IniEdit
        .IniFilePath = p_FilePath
        lngPatternCount = .GetSectionNames(colPattern)
    End With
    
End Property

Public Property Let dScale(s As Double)
    dblScale = s
End Property

Public Property Let dMag(m As Double)
    dblMagnification = m
End Property



'p^[
Public Function Count() As Long
    Count = lngPatternCount
End Function

Public Function Item(Num As Long) As String
    Item = colPattern.Item(Num)
End Function

Public Function GetPattern(Name As String, ByRef colPrim As Collection) As Double

    Dim colKey As Collection
    Dim lngKeyCount As Long
    Dim RapidPoints As zwDrawCAD.DPoints
    Dim RapidPolyLine As zwDrawCAD.PolyLineData
    Dim RapidLine As zwDrawCAD.LineData
    Dim RapidCircle As zwDrawCAD.CircleData
    Dim RapidRegionCircle  As zwDrawCAD.RegionData
    Dim RapidPoint As zwDrawCAD.DPoint
    Dim RapidArc As zwDrawCAD.ArcData
    Dim strKeyName As String
    Dim strSplit() As String
    Dim i As Long
    Dim j As Long
    Dim ms As Double
    ms = dblScale * dblMagnification / 100
    
    Set colKey = New Collection
    
    lngKeyCount = c_IniEdit.GetKeyNames(Name, colKey)
        
    For i = 1 To lngKeyCount
        strKeyName = colKey.Item(i)
        Select Case Left(strKeyName, 1)
            Case Is = "W"
                GetPattern = CDbl(c_IniEdit.GetInt(Name, strKeyName, 0) * ms)
            Case Is = "P"
                strSplit = Split(c_IniEdit.GetString(Name, strKeyName, ""))
                Set RapidPoints = New zwDrawCAD.DPoints
                For j = 0 To UBound(strSplit) Step 2
                    RapidPoints.Add CDbl(strSplit(j)) * ms, CDbl(strSplit(j + 1) * ms)
                Next j
                Set RapidPolyLine = New zwDrawCAD.PolyLineData
                RapidPolyLine.Create zwPolyPolyLine, RapidPoints
                colPrim.Add RapidPolyLine
                Set RapidPolyLine = Nothing
                Set RapidPoints = Nothing
            Case Is = "L"
                strSplit = Split(c_IniEdit.GetString(Name, strKeyName, ""))
                Set RapidLine = New zwDrawCAD.LineData
                With RapidLine
                    .Start.x = CDbl(strSplit(0)) * ms
                    .Start.y = CDbl(strSplit(1)) * ms
                    .End.x = CDbl(strSplit(2)) * ms
                    .End.y = CDbl(strSplit(3)) * ms
                End With
                colPrim.Add RapidLine
                Set RapidLine = Nothing
            Case Is = "C"
                strSplit = Split(c_IniEdit.GetString(Name, strKeyName, ""))
                Set RapidCircle = New zwDrawCAD.CircleData
                With RapidCircle
                    .Center.x = CDbl(strSplit(0)) * ms
                    .Center.y = CDbl(strSplit(1)) * ms
                    .Radius = CDbl(strSplit(2)) * ms
                End With
                colPrim.Add RapidCircle
                Set RapidCircle = Nothing
            Case Is = "A"
                strSplit = Split(c_IniEdit.GetString(Name, strKeyName, ""))
                Set RapidArc = New zwDrawCAD.ArcData
                With RapidArc
                    .Center.x = CDbl(strSplit(0)) * ms
                    .Center.y = CDbl(strSplit(1)) * ms
                    .Start.x = CDbl(strSplit(2)) * ms
                    .Start.y = CDbl(strSplit(3)) * ms
                    .End.x = CDbl(strSplit(4)) * ms
                    .End.y = CDbl(strSplit(5)) * ms
                    .Radius = CDbl(strSplit(6)) * ms
                End With
                colPrim.Add RapidArc
                Set RapidArc = Nothing
            Case Is = "R"
                strSplit = Split(c_IniEdit.GetString(Name, strKeyName, ""))
                Set RapidRegionCircle = New zwDrawCAD.RegionData
                Set RapidPoint = New zwDrawCAD.DPoint
                RapidPoint.x = CDbl(strSplit(0)) * ms
                RapidPoint.y = CDbl(strSplit(1)) * ms
                RapidRegionCircle.CreateCircle zwRgnSolid, RapidPoint, CDbl(strSplit(2)) * ms
                colPrim.Add RapidRegionCircle
                Set RapidRegionCircle = Nothing
                Set RapidPoint = Nothing
            Case Else
            
        End Select
    Next i
    
    Set RapidPoints = Nothing
    Set RapidPolyLine = Nothing
    Set RapidLine = Nothing
    Set RapidCircle = Nothing
    Set RapidArc = Nothing
    Set colKey = Nothing
    
End Function
