Attribute VB_Name = "M_Calc"
'΂DoublelԂ
'
Public Function Pi() As Double

    Pi = 4 * Atn(1)

End Function

'2_̋Ԃ
'
Public Function Length(ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double) As Double

    Length = Sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2)

End Function

'2_̊px(WA)Ԃ
'http://www.inet-lab.org/ted/program/prog020.html#020.8
'
Public Function Angle(ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double) As Double
   
'   DX | + | - | - | + |
'   DY | + | + | - | - |
'  ----+---+---+---+---|
'  ی| 1 | 2 | 3 | 4 |

    Dim dx As Double
    Dim dy As Double
    Dim t As Double
    Dim a As Double
    Dim area As Integer
    
    dx = x2 - x1
    dy = y2 - y1
    
    If dx >= 0 Then
        If dy >= 0 Then             'Pی
            area = 0
        Else                        'Sی
            area = 3
            t = dx
            dx = dy * -1
            dy = t
        End If
    Else
        If dy >= 0 Then             'Qی
            area = 1
            t = dx
            dx = dy
            dy = t * -1
        Else                        'Rی
            area = 2
            dx = dx * -1
            dy = dy * -1
        End If
    End If
    
    If dy > dx Then
        a = Pi / 2 - Atn(dx / dy)   'STxȏ
    Else
        a = Atn(dy / dx)            'STxȉ
    End If
    
    Angle = a + area * (Pi / 2)

End Function

'Wl]
'http://www.inet-lab.org/ted/program/prog016.html#016.1
'
'   xc,yc    :]̒SW
'       rot      :]px (P = WA)
'       xsrc,ysrc:]O̍W
'       xret,yret:]̍Wl
'
Private Sub Rotation(ByVal xc As Double, ByVal yc As Double, ByVal rot As Double, _
                     ByVal xsrc As Double, ByVal ysrc As Double, _
                     ByRef xret As Double, ByRef yret As Double)

    Dim cc As Double
    Dim ss As Double
    
    cc = Cos(rot * -1)
    ss = Sin(rot * -1)
    
    xsrc = xsrc - xc
    ysrc = ysrc - yc
    
    xret = (xsrc * cc) + (ysrc * ss) + xc
    yret = (xsrc * ss * -1) + (ysrc * cc) + yc
        
End Sub

'Ɖ~̌_߂
'http://www.inet-lab.org/ted/program/prog146.html#146.2
'http://www.inet-lab.org/ted/program/prog016.html#016.2
'
'   xc,yc    :~̒SW
'       r        :~̔a
'       xl1,yl1  :̒[_ 1
'       xl2,yl2  :̒[_ 2
'       xp1,yp1  :_1
'       xp2,yp2  :_2
'߂l@@@@@:_
'
Private Function Cross_CL(ByVal xc As Double, ByVal yc As Double, ByVal r As Double, _
                          ByVal xl1 As Double, ByVal yl1 As Double, ByVal xl2 As Double, ByVal yl2 As Double, _
                          ByRef xp1 As Double, ByRef yp1 As Double, ByRef xp2 As Double, ByRef yp2 As Double) As Integer
    Dim a As Double
    Dim xt As Double
    Dim yt As Double
    Dim x As Double
    
    a = Angle(xl1, yl1, xl2, yl2)
    '(xl1,yl1)_ɂĉ~̒SW̊px]
    Call Rotation(0, 0, a * -1, xc - xl1, yc - yl1, xt, yt)
                     
    If Abs(yt) > r Then
        Cross_CL = 0
        Exit Function
    End If
    
    x = Sqr(r * r - yt * yt)

    Call Rotation(xc, yc, a, xc + x, yc - yt, xp1, yp1)
    
    If x = 0 Then
        Cross_CL = 1
        Exit Function
    End If
    
    Call Rotation(xc, yc, a, xc - x, yc - yt, xp2, yp2)
    
    Cross_CL = 2
    
End Function

'1_Ɖ~̌_߂
'http://www.inet-lab.org/ted/program/prog146.html#146.2
'http://www.inet-lab.org/ted/program/prog016.html#016.2
'
'   xc,yc    :~̒SW
'       r        :~̔a
'       xl1,yl1  :̒[_ 1
'       xl2,yl2  :̒[_ 2
'       xp,yp    :_
'
Public Sub Cross_CSL(ByVal xc As Double, ByVal yc As Double, ByVal r As Double, _
                     ByVal xl1 As Double, ByVal yl1 As Double, ByVal xl2 As Double, ByVal yl2 As Double, _
                     ByRef xp As Double, ByRef yp As Double)
    Dim a As Double
    Dim xt As Double
    Dim yt As Double
    Dim x As Double
    
    a = Angle(xl1, yl1, xl2, yl2)
    
    Call Rotation(0, 0, a * -1, xc - xl1, yc - yl1, xt, yt)
    
    x = Sqr(r * r - yt * yt)

    If xt > Length(xl1, yl1, xl2, yl2) / 2 Then

        Call Rotation(xc, yc, a, xc - x, yc - yt, xp, yp)
    
    Else
    
        Call Rotation(xc, yc, a, xc + x, yc - yt, xp, yp)

    End If
    
End Sub

'̍W߂
Public Sub LegL(ByVal dir As Boolean, ByVal lleg As Double, _
                   ByVal x1 As Double, ByVal y1 As Double, _
                   ByVal x2 As Double, ByVal y2 As Double, _
                   ByVal x3 As Double, ByVal y3 As Double, _
                   ByRef xp As Double, ByRef yp As Double)
    Dim a As Double
    Dim xn As Double
    Dim yn As Double
    
    a = Angle(x1, y1, x3, y3)
    
    Call Rotation(x1, y1, a * -1, x2, y2, xn, yn)
    
    If dir = True Then  'Ȅꍇ
        yn = yn - lleg
    Else
        yn = yn + lleg
    End If
    
    Call Rotation(x1, y1, a, xn, yn, xp, yp)
    
End Sub

'̃qQ̍W߂
Public Sub LegL2(ByVal dir As Boolean, ByVal lleg As Double, _
                   ByVal cnt As Integer, ByVal hl As Double, _
                   ByVal x1 As Double, ByVal y1 As Double, _
                   ByVal x2 As Double, ByVal y2 As Double, _
                   ByVal x3 As Double, ByVal y3 As Double, _
                   ByRef p As Collection)
    Dim a As Double
    Dim xp() As Double
    Dim yp() As Double
    Dim xn() As Double
    Dim yn() As Double
    Dim i As Integer
    Dim D As Integer
    Dim h As Double
    
    If dir = True Then  'Ȅꍇ
        D = -1
    Else
        D = 1
    End If
    
    ReDim xp(cnt * 2)
    ReDim yp(cnt * 2)
    ReDim xn(cnt * 2)
    ReDim yn(cnt * 2)
    
    a = Angle(x1, y1, x3, y3)
    
    Call Rotation(x1, y1, a * -1, x2, y2, xn(0), yn(0))
    
    h = (lleg * D) / (cnt + 1)
        
    yn(0) = yn(0) + lleg * D - h
    
    For i = 0 To (cnt * 2) - 1 Step 2
        xn(i) = xn(0)
        yn(i) = yn(0) - h * (i / 2)
        xn(i + 1) = xn(0) - hl
        yn(i + 1) = yn(i)
    Next
    
    For i = 0 To cnt * 2
        Call Rotation(x1, y1, a, xn(i), yn(i), xp(i), yp(i))
        p.Add xp(i)
        p.Add yp(i)
    Next
    
End Sub

'~ʂ̒SW߂
Public Sub HeadArc(ByVal dir As Boolean, ByVal r As Double, _
                   ByVal x1 As Double, ByVal y1 As Double, _
                   ByVal x2 As Double, ByVal y2 As Double, _
                   ByRef xp As Double, ByRef yp As Double)
    Dim a As Double
    Dim xn As Double
    Dim yn As Double
    Dim x As Double
    
    a = Angle(x1, y1, x2, y2)
    
    Call Rotation(x1, y1, a * -1, (x1 + x2) / 2, (y1 + y2) / 2, xn, yn)
    
    x = Sqr(r ^ 2 - (xn - x1) ^ 2)
    
    If dir = True Then  'Ȅꍇ
        yn = yn - x
    Else
        yn = yn + x
    End If
    
    Call Rotation(x1, y1, a, xn, yn, xp, yp)
    
End Sub

'Ƃ񂪂蓪̍W߂
Public Sub HeadTri(ByVal dir As Boolean, ByVal t As Double, _
                   ByVal x1 As Double, ByVal y1 As Double, _
                   ByVal x2 As Double, ByVal y2 As Double, _
                   ByRef xp As Double, ByRef yp As Double)
    Dim a As Double
    Dim xn As Double
    Dim yn As Double
    
    a = Angle(x1, y1, x2, y2)
    
    Call Rotation(x1, y1, a * -1, (x1 + x2) / 2, (y1 + y2) / 2, xn, yn)
       
    If dir = True Then  'Ȅꍇ
        yn = yn + t
    Else
        yn = yn - t
    End If
    
    Call Rotation(x1, y1, a, xn, yn, xp, yp)
    
End Sub

'_̍W߂
Public Sub HorL(ByVal dir As Boolean, ByVal l As Double, ByVal t As Double, _
                   ByVal x1 As Double, ByVal y1 As Double, _
                   ByVal x2 As Double, ByVal y2 As Double, _
                   ByRef xp1 As Double, ByRef yp1 As Double, _
                   ByRef xp2 As Double, ByRef yp2 As Double)
    Dim a As Double
    Dim xn As Double
    Dim yn As Double
    
    a = Angle(x1, y1, x2, y2)
    
    Call Rotation(x1, y1, a * -1, (x1 + x2) / 2, (y1 + y2) / 2, xn, yn)
       
    If dir = True Then  'Ȅꍇ
        yn = yn - t
    Else
        yn = yn + t
    End If
    
    Call Rotation(x1, y1, a, xn - l / 2, yn, xp1, yp1)
    Call Rotation(x1, y1, a, xn + l / 2, yn, xp2, yp2)
    
End Sub



'ItZbg|Cg߂
Public Sub GetOffsetPoints(Width As Double, isRight As Boolean, _
                           ByVal OriginPoints As zwDrawCAD.DPoints, ByRef O_Points As zwDrawCAD.DPoints)
    Dim i As Long
    Dim xp(4) As Double
    Dim yp(4) As Double
    Dim blnCross As Boolean
    
    With OriginPoints
        If .Count = 2 Then
            Call Offset_L(Width, isRight, .Item(0).x, .Item(0).y, .Item(1).x, .Item(1).y, xp(0), yp(0), xp(1), yp(1))
            O_Points.Add xp(0), yp(0)
            O_Points.Add xp(1), yp(1)
        Else
            For i = 0 To .Count - 3
                Call Offset_L(Width, isRight, .Item(i).x, .Item(i).y, .Item(i + 1).x, .Item(i + 1).y, xp(0), yp(0), xp(1), yp(1))
                Call Offset_L(Width, isRight, .Item(i + 1).x, .Item(i + 1).y, .Item(i + 2).x, .Item(i + 2).y, xp(2), yp(2), xp(3), yp(3))
                If i = 0 Then
                    O_Points.Add xp(0), yp(0)
                End If
                blnCross = Cross_LL(xp(0), yp(0), xp(1), yp(1), xp(2), yp(2), xp(3), yp(3), xp(4), yp(4))
                If blnCross = True Then
                    O_Points.Add xp(4), yp(4)
                Else
                    O_Points.Add xp(1), yp(1)
                End If
                If i = .Count - 3 Then
                    O_Points.Add xp(3), yp(3)
                End If
            Next
        End If
    End With
End Sub

'ItZbg
'
'   w                :ItZbg
'       d                :EȂTrueȂFalse
'       x1,y1,x2,y2      :̎nI_
'       xp1,yp1,xp2,yp2  :ItZbg̎nI_
'
Public Sub Offset_L(ByVal w As Double, ByVal D As Boolean, _
                    ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double, _
                    ByRef xp1 As Double, ByRef yp1 As Double, ByRef xp2 As Double, ByRef yp2 As Double)
    Dim a As Double
    
    a = Angle(x1, y1, x2, y2)
    
    Call Rotation(x1, y1, a * -1, x2, y2, x2, y2)

    xp1 = x1
    xp2 = x2
    If D = True Then
        yp1 = y1 - w
        yp2 = y2 - w
    Else
        yp1 = y1 + w
        yp2 = y2 + w
    End If
    
    Call Rotation(x1, y1, a, xp1, yp1, xp1, yp1)
    Call Rotation(x1, y1, a, xp2, yp2, xp2, yp2)

End Sub

'2̌_߂
'http://www.inet-lab.org/ted/program/prog231.html
'
'   x11,y11,x12,y12  :1̎nI_
'       x21,y21,x22,y22  :2̎nI_
'       xp,yp            :_
'߂l(Boolean)         :ꍇ=True
'
Public Function Cross_LL(ByVal x11 As Double, ByVal y11 As Double, ByVal x12 As Double, ByVal y12 As Double, _
                         ByVal x21 As Double, ByVal y21 As Double, ByVal x22 As Double, ByVal y22 As Double, _
                         ByRef xp As Double, ByRef yp As Double) As Boolean
    Dim a As Double
    Dim xpy As Double
    Dim xt As Double
    Dim yt As Double
    
    a = Angle(x11, y11, x12, y12)
    
    Call Rotation(x11, y11, a * -1, x21, y21, x21, y21)
    Call Rotation(x11, y11, a * -1, x22, y22, x22, y22)

    If y21 = y22 Then
        Cross_LL = False
        Exit Function
    End If
    
    xpy = (x22 - x21) / (y22 - y21)
    
    xt = (y11 - y21) * xpy + x21
    
    yt = y11
    
    Call Rotation(x11, y11, a, xt, yt, xp, yp)
    
    Cross_LL = True

End Function

